//-------------------------------------------------------------------
//!AvP[VۊNXwb_
//!@memo 08/05/13 mmm
//-------------------------------------------------------------------

#ifndef __MMM_AAPPBASE_H__
#define __MMM_AAPPBASE_H__

#include <windows.h>
#include "MMMAWindow.h"

namespace mmm
{
	//-------------------------------------------------------------------
	//!AvP[V̒ۊNX
	//-------------------------------------------------------------------
	class AAppBase
	{
	public:
		//!IR[h
		enum{ EXIT_NORMAL, EXIT_ERROR, };
	public:
		//!XVʒl
		enum{ UPDATE_RUN, UPDATE_PAUSE, UPDATE_EXIT };
	public:
		AAppBase() : exitCode_(EXIT_ERROR), quit_(false){}
		virtual ~AAppBase(){}
	public:
		bool IsQuit(){ return quit_; }
		int GetExitCode(){ return exitCode_; }
	public:
		//!AvP[V̎s֐
		//!@memo@AvP[V̊{Iȗ
		void Run(HINSTANCE hInst)
		{
			hInst_ = hInst;
			if(Init() == false){ exitCode_ = EXIT_ERROR; return; }

			//bZ[W[v
			MSG msg;
			for(;;)
			{
				if(PeekMessage(&msg, 0, 0, 0, PM_REMOVE))
				{
					//IbZ[WI
					if(msg.message == WM_QUIT)
					{
						quit_ = true;
						continue;
					}

					DispatchMessage(&msg);
				}
				else
				{
					switch(Update())
					{
					case AAppBase::UPDATE_RUN:
					break;
					case AAppBase::UPDATE_PAUSE:
						WaitMessage();
					break;
					case UPDATE_EXIT:
						goto EXIT;
					break;
					};
				}
			}
	EXIT:
			if(Release() == false){ exitCode_ = EXIT_ERROR; return; }
		}
	private:
		//AvP[V̊e֐
		//@memo@hNXłꂼꏈs

		virtual bool Init() = 0;
		virtual int Update() = 0;
		virtual bool Release() = 0;

	protected:
		//hNXp̃IuWFNg̐֐
		//@memo@ꉞCX^XnhB

		bool CreateMyWindow(mmm::AWindow* pOut, int w, int h, const LPSTR title)
		{
			return mmm::CreateWindowUTL(pOut, hInst_, w, h, title);
		}
	private:
		bool quit_;			//!<IʒmtO
		int exitCode_;		//!<Il
		HINSTANCE hInst_;	//!<CX^Xnh
	};
};

#endif