//-------------------------------------------------------------------
//!_CNgwNXւ̂܂Ƃ߃Tv\[X
//!@memo 08/05/29 mmm
//-------------------------------------------------------------------

//-------------------------------------------------------------------
#include <windows.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <tchar.h>
#include <stdarg.h>
#include "MMMAWindow.h"
#include "MMMAAppBase.h"
#include "MMMGraphic.h"

//-------------------------------------------------------------------
#define	WINDOW_TITLE	"eXgEBhE"	//!<^Cg
#define	SCREEN_WIDTH	640					//!<
#define	SCREEN_HEIGHT	480					//!<c

//-------------------------------------------------------------------
//!CEBhENX
//-------------------------------------------------------------------
class MainWindow : public mmm::AWindow
{
public:
	MainWindow()
	{
		//TODO:ŃX^CȂǂݒ
		SetStyle(WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX);
		SetStyleEx(0);
		SetRegisterName("TEST");
	}
	virtual ~MainWindow(){}
private:
	virtual LRESULT	CALLBACK MyProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		//TODO:ł̃NXp̃vV[W`
		switch(msg)
		{
		case WM_DESTROY: PostQuitMessage(0); break;
		default: return AWindow::MyDefProc(hWnd, msg, wParam, lParam); break;
		};

		return	FALSE;
	}
};

//!Rcp_
struct MyVertex
{
	float x, y, z;
	DWORD color;
};

LPDIRECT3DVERTEXDECLARATION9 pVertDec = 0;
IDirect3DVertexBuffer9* pVB = 0;

//-------------------------------------------------------------------
//!eXgp̃AvP[VNX
//-------------------------------------------------------------------
class TestApp : public mmm::AAppBase
{
public:
	TestApp(){}
	virtual ~TestApp(){}
private:
	virtual bool Init()
	{
		//CEBhE
		if(CreateMyWindow(&mainWnd_, SCREEN_WIDTH, SCREEN_HEIGHT, WINDOW_TITLE) == false) return false;
		if(graphic_.Create(mainWnd_.GetHandle(), SCREEN_WIDTH, SCREEN_HEIGHT) == false) return false;
		if(dbgFont_.Create(&graphic_, 0, 18, 0, "lr ") == false) return false;

		LPDIRECT3DDEVICE9 pDev = graphic_.GetDevice();

		//_錾̒`
		D3DVERTEXELEMENT9 decl[] =
		{
			{0, 0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0},
			{0, sizeof(float)*3, D3DDECLTYPE_D3DCOLOR, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR, 0},
			D3DDECL_END()
		};
		if(FAILED(pDev->CreateVertexDeclaration(decl, &pVertDec)))
		{
			return false;
		}

		//_obt@̍쐬
		if(FAILED(pDev->CreateVertexBuffer(sizeof(MyVertex)*3, 0, D3DFVF_XYZ | D3DFVF_DIFFUSE, D3DPOOL_MANAGED, &pVB, 0)))
		{
			return false;
		}

		//_obt@փf[^ݒ
		MyVertex verts[] =
		{
			{ -1.0f,-1.0f, 0.0f, 0xff000000, },
			{  1.0f,-1.0f, 0.0f, 0xff000000, },
			{  0.0f, 1.0f, 0.0f, 0xffffffff, },
		};
		void* pVs = 0;
		pVB->Lock(0, sizeof(MyVertex)*3, &pVs, 0);
		memcpy(pVs, verts, sizeof(MyVertex)*3);
		pVB->Unlock();

		return true;
	}
	virtual int Update()
	{
		//IʒmĂI
		if(IsQuit()) return UPDATE_EXIT;
		if(mainWnd_.IsActive() == false) return UPDATE_PAUSE;

		//`揈s
		Render();

		return UPDATE_RUN;
	}
	virtual bool Release()
	{
		SafeReleaseD3D(pVB);
		SafeReleaseD3D(pVertDec);

		if(dbgFont_.Release() == false) return false;
		if(graphic_.Release() == false) return false;

		return true;
	}
	//!`֐
	void Render()
	{
		if(graphic_.IsCreated() == false) return;

		graphic_.Clear(mmm::Graphic::CLEAR_IMAGE | mmm::Graphic::CLEAR_Z, mmm::Graphic::ColorRGB(64, 64, 64), 1.f);

		//`Jn̐錾
		if(graphic_.BeginScene())
		{
			dbgFont_.DrawText(0, 0, mmm::DebugFont::ALIGN_RIGHT, mmm::Graphic::ColorRGB(255, 96, 96), "hello world version 3.");

			LPDIRECT3DDEVICE9 pDev = graphic_.GetDevice();

			D3DXMATRIX matWorld;
			D3DXMatrixRotationY(&matWorld, timeGetTime() / 150.0f);
			pDev->SetTransform(D3DTS_WORLD, &matWorld);

			D3DXVECTOR3 eye(0.0f, 0.0f,-5.0f);
			D3DXVECTOR3 at(0.0f, 0.0f, 0.0f);
			D3DXVECTOR3 up(0.0f, 1.0f, 0.0f);
			D3DXMATRIX matView;
			D3DXMatrixLookAtLH(&matView, &eye, &at, &up);
			pDev->SetTransform(D3DTS_VIEW, &matView);

			D3DXMATRIX matProj;
			D3DXMatrixPerspectiveFovLH(&matProj, D3DX_PI/3.f, 1.0f, 1.0f, 100.0f);
			pDev->SetTransform(D3DTS_PROJECTION, &matProj);

			pDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);
			pDev->SetRenderState(D3DRS_LIGHTING, FALSE);

			//_`̐ݒ
			pDev->SetVertexDeclaration(pVertDec);

			//gpf[^̐ݒ
			pDev->SetStreamSource(0, pVB, 0, sizeof(MyVertex));

			//ݒ肳ꂽf[^gĕ`
			pDev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 1);
		}
		//`I̐錾
		graphic_.EndScene();

		graphic_.Present();
	}
private:
	mmm::Graphic graphic_;		//!<OtBbN
	mmm::DebugFont dbgFont_;	//!<fobOtHg
	MainWindow mainWnd_;		//!<CEBhE
};
//-------------------------------------------------------------------
//!Windows ProgrammingɂĈԍŏɌĂ΂֐
//-------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdLine, int nCmdShow)
{
	hPrevInst;
	lpszCmdLine;
	nCmdShow;

	int exit = 0;
	{
		TestApp app;
		app.Run(hInst);
		exit = app.GetExitCode();
	}

	return exit;
}